import{S as Nf,i as If,s as Uf,e as s,k as p,w as u,t as r,M as Cf,c as n,d as a,m as f,a as o,x as d,h as i,b as h,G as t,g as c,y as m,q as _,o as v,B as y,v as Ff}from"../../chunks/vendor-hf-doc-builder.js";import{T as Rf}from"../../chunks/Tip-hf-doc-builder.js";import{I as D}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as k}from"../../chunks/CodeBlock-hf-doc-builder.js";function Mf($s){let g;return{c(){g=r(`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},l(A){g=i(A,`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},m(A,T){c(A,g,T)},d(A){A&&a(g)}}}function Vf($s){let g,A,T,re,Yt,Pe,Ln,Wt,Xn,Es,j,Yn,Kt,Wn,Kn,xe,Qn,Jn,ot,Zn,eo,js,rt,to,ks,ie,Qt,I,Ts,ao,Jt,so,no,Zt,oo,ro,w,U,ea,io,lo,ta,po,fo,aa,co,ho,C,sa,uo,mo,na,_o,vo,oa,yo,wo,F,ra,bo,go,ia,$o,Eo,la,jo,ko,R,pa,To,Do,fa,Ao,Po,ca,xo,So,M,ha,qo,No,ua,Io,Uo,da,Co,Fo,V,ma,Ro,Mo,_a,Vo,zo,va,Ho,Go,z,ya,Oo,Bo,wa,Lo,Xo,ba,Yo,Ds,it,Wo,As,H,le,ga,Se,Ko,$a,Qo,Ps,qe,Ne,Jo,Zo,xs,pe,er,Ea,tr,ar,Ss,Ie,qs,G,fe,ja,Ue,sr,ka,nr,Ns,ce,or,Ce,rr,ir,Is,Fe,Us,O,he,Ta,Re,lr,Da,pr,Cs,P,fr,Aa,cr,hr,Pa,ur,dr,Fs,Me,Rs,ue,mr,xa,_r,vr,Ms,B,de,Sa,Ve,yr,qa,wr,Vs,x,br,Na,gr,$r,Ia,Er,jr,zs,ze,Hs,L,me,Ua,He,kr,Ca,Tr,Gs,lt,Dr,Os,_e,Bs,ve,Ar,pt,Pr,xr,Ls,Ge,Xs,ft,Sr,Ys,X,ye,Fa,Oe,qr,Ra,Nr,Ws,ct,Ir,Ks,S,Ur,ht,Cr,Fr,ut,Rr,Mr,Qs,we,Vr,dt,zr,Hr,Js,Be,Zs,mt,Gr,en,Y,be,Ma,Le,Or,Va,Br,tn,_t,Lr,an,ge,Xr,vt,Yr,Wr,sn,Xe,nn,yt,Kr,on,wt,Qr,rn,Ye,ln,W,$e,za,We,Jr,Ha,Zr,pn,bt,ei,fn,gt,ti,cn,Ke,hn,K,Ee,Ga,Qe,ai,Oa,si,un,je,ni,Ba,oi,ri,dn,$t,ii,mn,Je,_n,ke,li,La,pi,fi,vn,Ze,yn,Q,Te,Xa,et,ci,Ya,hi,wn,q,ui,tt,di,mi,at,_i,vi,bn,Et,yi,gn,De,Wa,J,Ka,wi,bi,Qa,gi,$i,Ja,Ei,ji,b,Z,Za,ki,Ti,es,Di,Ai,ts,Pi,xi,ee,as,Si,qi,ss,Ni,Ii,ns,Ui,Ci,te,os,Fi,Ri,rs,Mi,Vi,is,zi,Hi,ae,ls,Gi,Oi,ps,Bi,Li,fs,Xi,Yi,se,cs,Wi,Ki,hs,Qi,Ji,us,Zi,el,ne,ds,tl,al,ms,sl,nl,_s,ol,rl,oe,vs,il,ll,ys,pl,fl,ws,cl,$n,jt,hl,En,N,bs,ul,dl,gs,ml,_l,kt,Tt,vl,yl,jn,st,kn;return Pe=new D({}),Se=new D({}),Ie=new k({props:{code:`import torch

torch.backends.cudnn.benchmark = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cudnn.benchmark = <span class="hljs-literal">True</span>`}}),Ue=new D({}),Fe=new k({props:{code:`import torch

torch.backends.cuda.matmul.allow_tf32 = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cuda.matmul.allow_tf32 = <span class="hljs-literal">True</span>`}}),Re=new D({}),Me=new k({props:{code:`from torch import autocast
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
with autocast("cuda"):
    image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">from</span> torch <span class="hljs-keyword">import</span> autocast
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
<span class="hljs-keyword">with</span> autocast(<span class="hljs-string">&quot;cuda&quot;</span>):
    image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ve=new D({}),ze=new k({props:{code:`pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),He=new D({}),_e=new Rf({props:{$$slots:{default:[Mf]},$$scope:{ctx:$s}}}),Ge=new k({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_attention_slicing()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_attention_slicing()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Oe=new D({}),Be=new k({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_vae_slicing()
images = pipe([prompt] * 32).images`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_vae_slicing()
images = pipe([prompt] * <span class="hljs-number">32</span>).images`}}),Le=new D({}),Xe=new k({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ye=new k({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),We=new D({}),Ke=new k({props:{code:`print(pipe.unet.conv_out.state_dict()["weight"].stride())  # (2880, 9, 3, 1)
pipe.unet.to(memory_format=torch.channels_last)  # in-place operation
print(
    pipe.unet.conv_out.state_dict()["weight"].stride()
)  # (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works`,highlighted:`<span class="hljs-built_in">print</span>(pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride())  <span class="hljs-comment"># (2880, 9, 3, 1)</span>
pipe.unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># in-place operation</span>
<span class="hljs-built_in">print</span>(
    pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride()
)  <span class="hljs-comment"># (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works</span>`}}),Qe=new D({}),Je=new k({props:{code:`import time
import torch
from diffusers import StableDiffusionPipeline
import functools

# torch disable grad
torch.set_grad_enabled(False)

# set variables
n_experiments = 2
unet_runs_per_experiment = 50

# load inputs
def generate_inputs():
    sample = torch.randn(2, 4, 64, 64).half().cuda()
    timestep = torch.rand(1).half().cuda() * 999
    encoder_hidden_states = torch.randn(2, 77, 768).half().cuda()
    return sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")
unet = pipe.unet
unet.eval()
unet.to(memory_format=torch.channels_last)  # use channels_last memory format
unet.forward = functools.partial(unet.forward, return_dict=False)  # set return_dict=False as default

# warmup
for _ in range(3):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

# trace
print("tracing..")
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.eval()
print("done tracing")


# warmup and optimize graph
for _ in range(5):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


# benchmarking
with torch.inference_mode():
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        print(f"unet traced inference took {time.time() - start_time:.2f} seconds")
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        print(f"unet inference took {time.time() - start_time:.2f} seconds")

# save the model
unet_traced.save("unet_traced.pt")`,highlighted:`<span class="hljs-keyword">import</span> time
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> functools

<span class="hljs-comment"># torch disable grad</span>
torch.set_grad_enabled(<span class="hljs-literal">False</span>)

<span class="hljs-comment"># set variables</span>
n_experiments = <span class="hljs-number">2</span>
unet_runs_per_experiment = <span class="hljs-number">50</span>

<span class="hljs-comment"># load inputs</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_inputs</span>():
    sample = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">4</span>, <span class="hljs-number">64</span>, <span class="hljs-number">64</span>).half().cuda()
    timestep = torch.rand(<span class="hljs-number">1</span>).half().cuda() * <span class="hljs-number">999</span>
    encoder_hidden_states = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">77</span>, <span class="hljs-number">768</span>).half().cuda()
    <span class="hljs-keyword">return</span> sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)
unet = pipe.unet
unet.<span class="hljs-built_in">eval</span>()
unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># use channels_last memory format</span>
unet.forward = functools.partial(unet.forward, return_dict=<span class="hljs-literal">False</span>)  <span class="hljs-comment"># set return_dict=False as default</span>

<span class="hljs-comment"># warmup</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">3</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

<span class="hljs-comment"># trace</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;tracing..&quot;</span>)
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.<span class="hljs-built_in">eval</span>()
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;done tracing&quot;</span>)


<span class="hljs-comment"># warmup and optimize graph</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">5</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


<span class="hljs-comment"># benchmarking</span>
<span class="hljs-keyword">with</span> torch.inference_mode():
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet traced inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)

<span class="hljs-comment"># save the model</span>
unet_traced.save(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)`}}),Ze=new k({props:{code:`from diffusers import StableDiffusionPipeline
import torch
from dataclasses import dataclass


@dataclass
class UNet2DConditionOutput:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

# use jitted unet
unet_traced = torch.jit.load("unet_traced.pt")
# del pipe.unet
class TracedUNet(torch.nn.Module):
    def __init__(self):
        super().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    def forward(self, latent_model_input, t, encoder_hidden_states):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[0]
        return UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

with torch.inference_mode():
    image = pipe([prompt] * 1, num_inference_steps=50).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">UNet2DConditionOutput</span>:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># use jitted unet</span>
unet_traced = torch.jit.load(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)
<span class="hljs-comment"># del pipe.unet</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TracedUNet</span>(torch.nn.Module):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
        <span class="hljs-built_in">super</span>().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, latent_model_input, t, encoder_hidden_states</span>):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[<span class="hljs-number">0</span>]
        <span class="hljs-keyword">return</span> UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

<span class="hljs-keyword">with</span> torch.inference_mode():
    image = pipe([prompt] * <span class="hljs-number">1</span>, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]`}}),et=new D({}),st=new k({props:{code:`from diffusers import StableDiffusionPipeline
import torch

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

pipe.enable_xformers_memory_efficient_attention()

with torch.inference_mode():
    sample = pipe("a small cat")

# optional: You can disable it via
# pipe.disable_xformers_memory_efficient_attention()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-keyword">with</span> torch.inference_mode():
    sample = pipe(<span class="hljs-string">&quot;a small cat&quot;</span>)

<span class="hljs-comment"># optional: You can disable it via</span>
<span class="hljs-comment"># pipe.disable_xformers_memory_efficient_attention()</span>`}}),{c(){g=s("meta"),A=p(),T=s("h1"),re=s("a"),Yt=s("span"),u(Pe.$$.fragment),Ln=p(),Wt=s("span"),Xn=r("Memory and speed"),Es=p(),j=s("p"),Yn=r("We present some techniques and ideas to optimize \u{1F917} Diffusers "),Kt=s("em"),Wn=r("inference"),Kn=r(" for memory or speed. As a general rule, we recommend the use of "),xe=s("a"),Qn=r("xFormers"),Jn=r(" for memory efficient attention, please see the recommended "),ot=s("a"),Zn=r("installation instructions"),eo=r("."),js=p(),rt=s("p"),to=r("We\u2019ll discuss how the following settings impact performance and memory."),ks=p(),ie=s("table"),Qt=s("thead"),I=s("tr"),Ts=s("th"),ao=p(),Jt=s("th"),so=r("Latency"),no=p(),Zt=s("th"),oo=r("Speedup"),ro=p(),w=s("tbody"),U=s("tr"),ea=s("td"),io=r("original"),lo=p(),ta=s("td"),po=r("9.50s"),fo=p(),aa=s("td"),co=r("x1"),ho=p(),C=s("tr"),sa=s("td"),uo=r("cuDNN auto-tuner"),mo=p(),na=s("td"),_o=r("9.37s"),vo=p(),oa=s("td"),yo=r("x1.01"),wo=p(),F=s("tr"),ra=s("td"),bo=r("autocast (fp16)"),go=p(),ia=s("td"),$o=r("5.47s"),Eo=p(),la=s("td"),jo=r("x1.74"),ko=p(),R=s("tr"),pa=s("td"),To=r("fp16"),Do=p(),fa=s("td"),Ao=r("3.61s"),Po=p(),ca=s("td"),xo=r("x2.63"),So=p(),M=s("tr"),ha=s("td"),qo=r("channels last"),No=p(),ua=s("td"),Io=r("3.30s"),Uo=p(),da=s("td"),Co=r("x2.88"),Fo=p(),V=s("tr"),ma=s("td"),Ro=r("traced UNet"),Mo=p(),_a=s("td"),Vo=r("3.21s"),zo=p(),va=s("td"),Ho=r("x2.96"),Go=p(),z=s("tr"),ya=s("td"),Oo=r("memory efficient attention"),Bo=p(),wa=s("td"),Lo=r("2.63s"),Xo=p(),ba=s("td"),Yo=r("x3.61"),Ds=p(),it=s("em"),Wo=r(`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),As=p(),H=s("h2"),le=s("a"),ga=s("span"),u(Se.$$.fragment),Ko=p(),$a=s("span"),Qo=r("Enable cuDNN auto-tuner"),Ps=p(),qe=s("p"),Ne=s("a"),Jo=r("NVIDIA cuDNN"),Zo=r("\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),xs=p(),pe=s("p"),er=r("Since we\u2019re using "),Ea=s("strong"),tr=r("convolutional networks"),ar=r(" (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),Ss=p(),u(Ie.$$.fragment),qs=p(),G=s("h3"),fe=s("a"),ja=s("span"),u(Ue.$$.fragment),sr=p(),ka=s("span"),nr=r("Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Ns=p(),ce=s("p"),or=r("On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Ce=s("a"),rr=r("here"),ir=r(". All you need to do is to add this before your inference:"),Is=p(),u(Fe.$$.fragment),Us=p(),O=s("h2"),he=s("a"),Ta=s("span"),u(Re.$$.fragment),lr=p(),Da=s("span"),pr=r("Automatic mixed precision (AMP)"),Cs=p(),P=s("p"),fr=r("If you use a CUDA GPU, you can take advantage of "),Aa=s("code"),cr=r("torch.autocast"),hr=r(" to perform inference roughly twice as fast at the cost of slightly lower precision. All you need to do is put your inference call inside an "),Pa=s("code"),ur=r("autocast"),dr=r(" context manager. The following example shows how to do it using Stable Diffusion text-to-image generation as an example:"),Fs=p(),u(Me.$$.fragment),Rs=p(),ue=s("p"),mr=r("Despite the precision loss, in our experience the final image results look the same as the "),xa=s("code"),_r=r("float32"),vr=r(" versions. Feel free to experiment and report back!"),Ms=p(),B=s("h2"),de=s("a"),Sa=s("span"),u(Ve.$$.fragment),yr=p(),qa=s("span"),wr=r("Half precision weights"),Vs=p(),x=s("p"),br=r("To save more GPU memory and get even more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Na=s("code"),gr=r("fp16"),$r=r(", and telling PyTorch to use the "),Ia=s("code"),Er=r("float16"),jr=r(" type when loading them:"),zs=p(),u(ze.$$.fragment),Hs=p(),L=s("h2"),me=s("a"),Ua=s("span"),u(He.$$.fragment),kr=p(),Ca=s("span"),Tr=r("Sliced attention for additional memory savings"),Gs=p(),lt=s("p"),Dr=r("For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Os=p(),u(_e.$$.fragment),Bs=p(),ve=s("p"),Ar=r("To perform the attention computation sequentially over each head, you only need to invoke "),pt=s("a"),Pr=r("enable_attention_slicing()"),xr=r(" in your pipeline before inference, like here:"),Ls=p(),u(Ge.$$.fragment),Xs=p(),ft=s("p"),Sr=r("There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),Ys=p(),X=s("h2"),ye=s("a"),Fa=s("span"),u(Oe.$$.fragment),qr=p(),Ra=s("span"),Nr=r("Sliced VAE decode for larger batches"),Ws=p(),ct=s("p"),Ir=r("To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),Ks=p(),S=s("p"),Ur=r("You likely want to couple this with "),ht=s("a"),Cr=r("enable_attention_slicing()"),Fr=r(" or "),ut=s("a"),Rr=r("enable_xformers_memory_efficient_attention()"),Mr=r(" to further minimize memory use."),Qs=p(),we=s("p"),Vr=r("To perform the VAE decode one image at a time, invoke "),dt=s("a"),zr=r("enable_vae_slicing()"),Hr=r(" in your pipeline before inference. For example:"),Js=p(),u(Be.$$.fragment),Zs=p(),mt=s("p"),Gr=r("You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),en=p(),Y=s("h2"),be=s("a"),Ma=s("span"),u(Le.$$.fragment),Or=p(),Va=s("span"),Br=r("Offloading to CPU with accelerate for memory savings"),tn=p(),_t=s("p"),Lr=r("For additional memory savings, you can offload the weights to CPU and load them to GPU when performing the forward pass."),an=p(),ge=s("p"),Xr=r("To perform CPU offloading, all you have to do is invoke "),vt=s("a"),Yr=r("enable_sequential_cpu_offload()"),Wr=r(":"),sn=p(),u(Xe.$$.fragment),nn=p(),yt=s("p"),Kr=r("And you can get the memory consumption to < 2GB."),on=p(),wt=s("p"),Qr=r("If is also possible to chain it with attention slicing for minimal memory consumption, running it in as little as < 800mb of GPU vRAM:"),rn=p(),u(Ye.$$.fragment),ln=p(),W=s("h2"),$e=s("a"),za=s("span"),u(We.$$.fragment),Jr=p(),Ha=s("span"),Zr=r("Using Channels Last memory format"),pn=p(),bt=s("p"),ei=r("Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),fn=p(),gt=s("p"),ti=r("For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),cn=p(),u(Ke.$$.fragment),hn=p(),K=s("h2"),Ee=s("a"),Ga=s("span"),u(Qe.$$.fragment),ai=p(),Oa=s("span"),si=r("Tracing"),un=p(),je=s("p"),ni=r("Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),Ba=s("code"),oi=r("ScriptFunction"),ri=r(" is returned that will be optimized using just-in-time compilation."),dn=p(),$t=s("p"),ii=r("To trace our UNet model, we can use the following:"),mn=p(),u(Je.$$.fragment),_n=p(),ke=s("p"),li=r("Then we can replace the "),La=s("code"),pi=r("unet"),fi=r(" attribute of the pipeline with the traced model like the following"),vn=p(),u(Ze.$$.fragment),yn=p(),Q=s("h2"),Te=s("a"),Xa=s("span"),u(et.$$.fragment),ci=p(),Ya=s("span"),hi=r("Memory Efficient Attention"),wn=p(),q=s("p"),ui=r("Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),tt=s("a"),di=r("code"),mi=r(", "),at=s("a"),_i=r("paper"),vi=r("."),bn=p(),Et=s("p"),yi=r("Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),gn=p(),De=s("table"),Wa=s("thead"),J=s("tr"),Ka=s("th"),wi=r("GPU"),bi=p(),Qa=s("th"),gi=r("Base Attention FP16"),$i=p(),Ja=s("th"),Ei=r("Memory Efficient Attention FP16"),ji=p(),b=s("tbody"),Z=s("tr"),Za=s("td"),ki=r("NVIDIA Tesla T4"),Ti=p(),es=s("td"),Di=r("3.5it/s"),Ai=p(),ts=s("td"),Pi=r("5.5it/s"),xi=p(),ee=s("tr"),as=s("td"),Si=r("NVIDIA 3060 RTX"),qi=p(),ss=s("td"),Ni=r("4.6it/s"),Ii=p(),ns=s("td"),Ui=r("7.8it/s"),Ci=p(),te=s("tr"),os=s("td"),Fi=r("NVIDIA A10G"),Ri=p(),rs=s("td"),Mi=r("8.88it/s"),Vi=p(),is=s("td"),zi=r("15.6it/s"),Hi=p(),ae=s("tr"),ls=s("td"),Gi=r("NVIDIA RTX A6000"),Oi=p(),ps=s("td"),Bi=r("11.7it/s"),Li=p(),fs=s("td"),Xi=r("21.09it/s"),Yi=p(),se=s("tr"),cs=s("td"),Wi=r("NVIDIA TITAN RTX"),Ki=p(),hs=s("td"),Qi=r("12.51it/s"),Ji=p(),us=s("td"),Zi=r("18.22it/s"),el=p(),ne=s("tr"),ds=s("td"),tl=r("A100-SXM4-40GB"),al=p(),ms=s("td"),sl=r("18.6it/s"),nl=p(),_s=s("td"),ol=r("29.it/s"),rl=p(),oe=s("tr"),vs=s("td"),il=r("A100-SXM-80GB"),ll=p(),ys=s("td"),pl=r("18.7it/s"),fl=p(),ws=s("td"),cl=r("29.5it/s"),$n=p(),jt=s("p"),hl=r("To leverage it just make sure you have:"),En=p(),N=s("ul"),bs=s("li"),ul=r("PyTorch > 1.12"),dl=p(),gs=s("li"),ml=r("Cuda available"),_l=p(),kt=s("li"),Tt=s("a"),vl=r("Installed the xformers library"),yl=r("."),jn=p(),u(st.$$.fragment),this.h()},l(e){const l=Cf('[data-svelte="svelte-1phssyn"]',document.head);g=n(l,"META",{name:!0,content:!0}),l.forEach(a),A=f(e),T=n(e,"H1",{class:!0});var nt=o(T);re=n(nt,"A",{id:!0,class:!0,href:!0});var gl=o(re);Yt=n(gl,"SPAN",{});var $l=o(Yt);d(Pe.$$.fragment,$l),$l.forEach(a),gl.forEach(a),Ln=f(nt),Wt=n(nt,"SPAN",{});var El=o(Wt);Xn=i(El,"Memory and speed"),El.forEach(a),nt.forEach(a),Es=f(e),j=n(e,"P",{});var Ae=o(j);Yn=i(Ae,"We present some techniques and ideas to optimize \u{1F917} Diffusers "),Kt=n(Ae,"EM",{});var jl=o(Kt);Wn=i(jl,"inference"),jl.forEach(a),Kn=i(Ae," for memory or speed. As a general rule, we recommend the use of "),xe=n(Ae,"A",{href:!0,rel:!0});var kl=o(xe);Qn=i(kl,"xFormers"),kl.forEach(a),Jn=i(Ae," for memory efficient attention, please see the recommended "),ot=n(Ae,"A",{href:!0});var Tl=o(ot);Zn=i(Tl,"installation instructions"),Tl.forEach(a),eo=i(Ae,"."),Ae.forEach(a),js=f(e),rt=n(e,"P",{});var Dl=o(rt);to=i(Dl,"We\u2019ll discuss how the following settings impact performance and memory."),Dl.forEach(a),ks=f(e),ie=n(e,"TABLE",{});var Tn=o(ie);Qt=n(Tn,"THEAD",{});var Al=o(Qt);I=n(Al,"TR",{});var Dt=o(I);Ts=n(Dt,"TH",{}),o(Ts).forEach(a),ao=f(Dt),Jt=n(Dt,"TH",{});var Pl=o(Jt);so=i(Pl,"Latency"),Pl.forEach(a),no=f(Dt),Zt=n(Dt,"TH",{});var xl=o(Zt);oo=i(xl,"Speedup"),xl.forEach(a),Dt.forEach(a),Al.forEach(a),ro=f(Tn),w=n(Tn,"TBODY",{});var $=o(w);U=n($,"TR",{});var At=o(U);ea=n(At,"TD",{});var Sl=o(ea);io=i(Sl,"original"),Sl.forEach(a),lo=f(At),ta=n(At,"TD",{});var ql=o(ta);po=i(ql,"9.50s"),ql.forEach(a),fo=f(At),aa=n(At,"TD",{});var Nl=o(aa);co=i(Nl,"x1"),Nl.forEach(a),At.forEach(a),ho=f($),C=n($,"TR",{});var Pt=o(C);sa=n(Pt,"TD",{});var Il=o(sa);uo=i(Il,"cuDNN auto-tuner"),Il.forEach(a),mo=f(Pt),na=n(Pt,"TD",{});var Ul=o(na);_o=i(Ul,"9.37s"),Ul.forEach(a),vo=f(Pt),oa=n(Pt,"TD",{});var Cl=o(oa);yo=i(Cl,"x1.01"),Cl.forEach(a),Pt.forEach(a),wo=f($),F=n($,"TR",{});var xt=o(F);ra=n(xt,"TD",{});var Fl=o(ra);bo=i(Fl,"autocast (fp16)"),Fl.forEach(a),go=f(xt),ia=n(xt,"TD",{});var Rl=o(ia);$o=i(Rl,"5.47s"),Rl.forEach(a),Eo=f(xt),la=n(xt,"TD",{});var Ml=o(la);jo=i(Ml,"x1.74"),Ml.forEach(a),xt.forEach(a),ko=f($),R=n($,"TR",{});var St=o(R);pa=n(St,"TD",{});var Vl=o(pa);To=i(Vl,"fp16"),Vl.forEach(a),Do=f(St),fa=n(St,"TD",{});var zl=o(fa);Ao=i(zl,"3.61s"),zl.forEach(a),Po=f(St),ca=n(St,"TD",{});var Hl=o(ca);xo=i(Hl,"x2.63"),Hl.forEach(a),St.forEach(a),So=f($),M=n($,"TR",{});var qt=o(M);ha=n(qt,"TD",{});var Gl=o(ha);qo=i(Gl,"channels last"),Gl.forEach(a),No=f(qt),ua=n(qt,"TD",{});var Ol=o(ua);Io=i(Ol,"3.30s"),Ol.forEach(a),Uo=f(qt),da=n(qt,"TD",{});var Bl=o(da);Co=i(Bl,"x2.88"),Bl.forEach(a),qt.forEach(a),Fo=f($),V=n($,"TR",{});var Nt=o(V);ma=n(Nt,"TD",{});var Ll=o(ma);Ro=i(Ll,"traced UNet"),Ll.forEach(a),Mo=f(Nt),_a=n(Nt,"TD",{});var Xl=o(_a);Vo=i(Xl,"3.21s"),Xl.forEach(a),zo=f(Nt),va=n(Nt,"TD",{});var Yl=o(va);Ho=i(Yl,"x2.96"),Yl.forEach(a),Nt.forEach(a),Go=f($),z=n($,"TR",{});var It=o(z);ya=n(It,"TD",{});var Wl=o(ya);Oo=i(Wl,"memory efficient attention"),Wl.forEach(a),Bo=f(It),wa=n(It,"TD",{});var Kl=o(wa);Lo=i(Kl,"2.63s"),Kl.forEach(a),Xo=f(It),ba=n(It,"TD",{});var Ql=o(ba);Yo=i(Ql,"x3.61"),Ql.forEach(a),It.forEach(a),$.forEach(a),Tn.forEach(a),Ds=f(e),it=n(e,"EM",{});var Jl=o(it);Wo=i(Jl,`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),Jl.forEach(a),As=f(e),H=n(e,"H2",{class:!0});var Dn=o(H);le=n(Dn,"A",{id:!0,class:!0,href:!0});var Zl=o(le);ga=n(Zl,"SPAN",{});var ep=o(ga);d(Se.$$.fragment,ep),ep.forEach(a),Zl.forEach(a),Ko=f(Dn),$a=n(Dn,"SPAN",{});var tp=o($a);Qo=i(tp,"Enable cuDNN auto-tuner"),tp.forEach(a),Dn.forEach(a),Ps=f(e),qe=n(e,"P",{});var wl=o(qe);Ne=n(wl,"A",{href:!0,rel:!0});var ap=o(Ne);Jo=i(ap,"NVIDIA cuDNN"),ap.forEach(a),Zo=i(wl,"\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),wl.forEach(a),xs=f(e),pe=n(e,"P",{});var An=o(pe);er=i(An,"Since we\u2019re using "),Ea=n(An,"STRONG",{});var sp=o(Ea);tr=i(sp,"convolutional networks"),sp.forEach(a),ar=i(An," (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),An.forEach(a),Ss=f(e),d(Ie.$$.fragment,e),qs=f(e),G=n(e,"H3",{class:!0});var Pn=o(G);fe=n(Pn,"A",{id:!0,class:!0,href:!0});var np=o(fe);ja=n(np,"SPAN",{});var op=o(ja);d(Ue.$$.fragment,op),op.forEach(a),np.forEach(a),sr=f(Pn),ka=n(Pn,"SPAN",{});var rp=o(ka);nr=i(rp,"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),rp.forEach(a),Pn.forEach(a),Ns=f(e),ce=n(e,"P",{});var xn=o(ce);or=i(xn,"On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Ce=n(xn,"A",{href:!0,rel:!0});var ip=o(Ce);rr=i(ip,"here"),ip.forEach(a),ir=i(xn,". All you need to do is to add this before your inference:"),xn.forEach(a),Is=f(e),d(Fe.$$.fragment,e),Us=f(e),O=n(e,"H2",{class:!0});var Sn=o(O);he=n(Sn,"A",{id:!0,class:!0,href:!0});var lp=o(he);Ta=n(lp,"SPAN",{});var pp=o(Ta);d(Re.$$.fragment,pp),pp.forEach(a),lp.forEach(a),lr=f(Sn),Da=n(Sn,"SPAN",{});var fp=o(Da);pr=i(fp,"Automatic mixed precision (AMP)"),fp.forEach(a),Sn.forEach(a),Cs=f(e),P=n(e,"P",{});var Ut=o(P);fr=i(Ut,"If you use a CUDA GPU, you can take advantage of "),Aa=n(Ut,"CODE",{});var cp=o(Aa);cr=i(cp,"torch.autocast"),cp.forEach(a),hr=i(Ut," to perform inference roughly twice as fast at the cost of slightly lower precision. All you need to do is put your inference call inside an "),Pa=n(Ut,"CODE",{});var hp=o(Pa);ur=i(hp,"autocast"),hp.forEach(a),dr=i(Ut," context manager. The following example shows how to do it using Stable Diffusion text-to-image generation as an example:"),Ut.forEach(a),Fs=f(e),d(Me.$$.fragment,e),Rs=f(e),ue=n(e,"P",{});var qn=o(ue);mr=i(qn,"Despite the precision loss, in our experience the final image results look the same as the "),xa=n(qn,"CODE",{});var up=o(xa);_r=i(up,"float32"),up.forEach(a),vr=i(qn," versions. Feel free to experiment and report back!"),qn.forEach(a),Ms=f(e),B=n(e,"H2",{class:!0});var Nn=o(B);de=n(Nn,"A",{id:!0,class:!0,href:!0});var dp=o(de);Sa=n(dp,"SPAN",{});var mp=o(Sa);d(Ve.$$.fragment,mp),mp.forEach(a),dp.forEach(a),yr=f(Nn),qa=n(Nn,"SPAN",{});var _p=o(qa);wr=i(_p,"Half precision weights"),_p.forEach(a),Nn.forEach(a),Vs=f(e),x=n(e,"P",{});var Ct=o(x);br=i(Ct,"To save more GPU memory and get even more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Na=n(Ct,"CODE",{});var vp=o(Na);gr=i(vp,"fp16"),vp.forEach(a),$r=i(Ct,", and telling PyTorch to use the "),Ia=n(Ct,"CODE",{});var yp=o(Ia);Er=i(yp,"float16"),yp.forEach(a),jr=i(Ct," type when loading them:"),Ct.forEach(a),zs=f(e),d(ze.$$.fragment,e),Hs=f(e),L=n(e,"H2",{class:!0});var In=o(L);me=n(In,"A",{id:!0,class:!0,href:!0});var wp=o(me);Ua=n(wp,"SPAN",{});var bp=o(Ua);d(He.$$.fragment,bp),bp.forEach(a),wp.forEach(a),kr=f(In),Ca=n(In,"SPAN",{});var gp=o(Ca);Tr=i(gp,"Sliced attention for additional memory savings"),gp.forEach(a),In.forEach(a),Gs=f(e),lt=n(e,"P",{});var $p=o(lt);Dr=i($p,"For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),$p.forEach(a),Os=f(e),d(_e.$$.fragment,e),Bs=f(e),ve=n(e,"P",{});var Un=o(ve);Ar=i(Un,"To perform the attention computation sequentially over each head, you only need to invoke "),pt=n(Un,"A",{href:!0});var Ep=o(pt);Pr=i(Ep,"enable_attention_slicing()"),Ep.forEach(a),xr=i(Un," in your pipeline before inference, like here:"),Un.forEach(a),Ls=f(e),d(Ge.$$.fragment,e),Xs=f(e),ft=n(e,"P",{});var jp=o(ft);Sr=i(jp,"There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),jp.forEach(a),Ys=f(e),X=n(e,"H2",{class:!0});var Cn=o(X);ye=n(Cn,"A",{id:!0,class:!0,href:!0});var kp=o(ye);Fa=n(kp,"SPAN",{});var Tp=o(Fa);d(Oe.$$.fragment,Tp),Tp.forEach(a),kp.forEach(a),qr=f(Cn),Ra=n(Cn,"SPAN",{});var Dp=o(Ra);Nr=i(Dp,"Sliced VAE decode for larger batches"),Dp.forEach(a),Cn.forEach(a),Ws=f(e),ct=n(e,"P",{});var Ap=o(ct);Ir=i(Ap,"To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),Ap.forEach(a),Ks=f(e),S=n(e,"P",{});var Ft=o(S);Ur=i(Ft,"You likely want to couple this with "),ht=n(Ft,"A",{href:!0});var Pp=o(ht);Cr=i(Pp,"enable_attention_slicing()"),Pp.forEach(a),Fr=i(Ft," or "),ut=n(Ft,"A",{href:!0});var xp=o(ut);Rr=i(xp,"enable_xformers_memory_efficient_attention()"),xp.forEach(a),Mr=i(Ft," to further minimize memory use."),Ft.forEach(a),Qs=f(e),we=n(e,"P",{});var Fn=o(we);Vr=i(Fn,"To perform the VAE decode one image at a time, invoke "),dt=n(Fn,"A",{href:!0});var Sp=o(dt);zr=i(Sp,"enable_vae_slicing()"),Sp.forEach(a),Hr=i(Fn," in your pipeline before inference. For example:"),Fn.forEach(a),Js=f(e),d(Be.$$.fragment,e),Zs=f(e),mt=n(e,"P",{});var qp=o(mt);Gr=i(qp,"You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),qp.forEach(a),en=f(e),Y=n(e,"H2",{class:!0});var Rn=o(Y);be=n(Rn,"A",{id:!0,class:!0,href:!0});var Np=o(be);Ma=n(Np,"SPAN",{});var Ip=o(Ma);d(Le.$$.fragment,Ip),Ip.forEach(a),Np.forEach(a),Or=f(Rn),Va=n(Rn,"SPAN",{});var Up=o(Va);Br=i(Up,"Offloading to CPU with accelerate for memory savings"),Up.forEach(a),Rn.forEach(a),tn=f(e),_t=n(e,"P",{});var Cp=o(_t);Lr=i(Cp,"For additional memory savings, you can offload the weights to CPU and load them to GPU when performing the forward pass."),Cp.forEach(a),an=f(e),ge=n(e,"P",{});var Mn=o(ge);Xr=i(Mn,"To perform CPU offloading, all you have to do is invoke "),vt=n(Mn,"A",{href:!0});var Fp=o(vt);Yr=i(Fp,"enable_sequential_cpu_offload()"),Fp.forEach(a),Wr=i(Mn,":"),Mn.forEach(a),sn=f(e),d(Xe.$$.fragment,e),nn=f(e),yt=n(e,"P",{});var Rp=o(yt);Kr=i(Rp,"And you can get the memory consumption to < 2GB."),Rp.forEach(a),on=f(e),wt=n(e,"P",{});var Mp=o(wt);Qr=i(Mp,"If is also possible to chain it with attention slicing for minimal memory consumption, running it in as little as < 800mb of GPU vRAM:"),Mp.forEach(a),rn=f(e),d(Ye.$$.fragment,e),ln=f(e),W=n(e,"H2",{class:!0});var Vn=o(W);$e=n(Vn,"A",{id:!0,class:!0,href:!0});var Vp=o($e);za=n(Vp,"SPAN",{});var zp=o(za);d(We.$$.fragment,zp),zp.forEach(a),Vp.forEach(a),Jr=f(Vn),Ha=n(Vn,"SPAN",{});var Hp=o(Ha);Zr=i(Hp,"Using Channels Last memory format"),Hp.forEach(a),Vn.forEach(a),pn=f(e),bt=n(e,"P",{});var Gp=o(bt);ei=i(Gp,"Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),Gp.forEach(a),fn=f(e),gt=n(e,"P",{});var Op=o(gt);ti=i(Op,"For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),Op.forEach(a),cn=f(e),d(Ke.$$.fragment,e),hn=f(e),K=n(e,"H2",{class:!0});var zn=o(K);Ee=n(zn,"A",{id:!0,class:!0,href:!0});var Bp=o(Ee);Ga=n(Bp,"SPAN",{});var Lp=o(Ga);d(Qe.$$.fragment,Lp),Lp.forEach(a),Bp.forEach(a),ai=f(zn),Oa=n(zn,"SPAN",{});var Xp=o(Oa);si=i(Xp,"Tracing"),Xp.forEach(a),zn.forEach(a),un=f(e),je=n(e,"P",{});var Hn=o(je);ni=i(Hn,"Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),Ba=n(Hn,"CODE",{});var Yp=o(Ba);oi=i(Yp,"ScriptFunction"),Yp.forEach(a),ri=i(Hn," is returned that will be optimized using just-in-time compilation."),Hn.forEach(a),dn=f(e),$t=n(e,"P",{});var Wp=o($t);ii=i(Wp,"To trace our UNet model, we can use the following:"),Wp.forEach(a),mn=f(e),d(Je.$$.fragment,e),_n=f(e),ke=n(e,"P",{});var Gn=o(ke);li=i(Gn,"Then we can replace the "),La=n(Gn,"CODE",{});var Kp=o(La);pi=i(Kp,"unet"),Kp.forEach(a),fi=i(Gn," attribute of the pipeline with the traced model like the following"),Gn.forEach(a),vn=f(e),d(Ze.$$.fragment,e),yn=f(e),Q=n(e,"H2",{class:!0});var On=o(Q);Te=n(On,"A",{id:!0,class:!0,href:!0});var Qp=o(Te);Xa=n(Qp,"SPAN",{});var Jp=o(Xa);d(et.$$.fragment,Jp),Jp.forEach(a),Qp.forEach(a),ci=f(On),Ya=n(On,"SPAN",{});var Zp=o(Ya);hi=i(Zp,"Memory Efficient Attention"),Zp.forEach(a),On.forEach(a),wn=f(e),q=n(e,"P",{});var Rt=o(q);ui=i(Rt,"Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),tt=n(Rt,"A",{href:!0,rel:!0});var ef=o(tt);di=i(ef,"code"),ef.forEach(a),mi=i(Rt,", "),at=n(Rt,"A",{href:!0,rel:!0});var tf=o(at);_i=i(tf,"paper"),tf.forEach(a),vi=i(Rt,"."),Rt.forEach(a),bn=f(e),Et=n(e,"P",{});var af=o(Et);yi=i(af,"Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),af.forEach(a),gn=f(e),De=n(e,"TABLE",{});var Bn=o(De);Wa=n(Bn,"THEAD",{});var sf=o(Wa);J=n(sf,"TR",{});var Mt=o(J);Ka=n(Mt,"TH",{});var nf=o(Ka);wi=i(nf,"GPU"),nf.forEach(a),bi=f(Mt),Qa=n(Mt,"TH",{});var of=o(Qa);gi=i(of,"Base Attention FP16"),of.forEach(a),$i=f(Mt),Ja=n(Mt,"TH",{});var rf=o(Ja);Ei=i(rf,"Memory Efficient Attention FP16"),rf.forEach(a),Mt.forEach(a),sf.forEach(a),ji=f(Bn),b=n(Bn,"TBODY",{});var E=o(b);Z=n(E,"TR",{});var Vt=o(Z);Za=n(Vt,"TD",{});var lf=o(Za);ki=i(lf,"NVIDIA Tesla T4"),lf.forEach(a),Ti=f(Vt),es=n(Vt,"TD",{});var pf=o(es);Di=i(pf,"3.5it/s"),pf.forEach(a),Ai=f(Vt),ts=n(Vt,"TD",{});var ff=o(ts);Pi=i(ff,"5.5it/s"),ff.forEach(a),Vt.forEach(a),xi=f(E),ee=n(E,"TR",{});var zt=o(ee);as=n(zt,"TD",{});var cf=o(as);Si=i(cf,"NVIDIA 3060 RTX"),cf.forEach(a),qi=f(zt),ss=n(zt,"TD",{});var hf=o(ss);Ni=i(hf,"4.6it/s"),hf.forEach(a),Ii=f(zt),ns=n(zt,"TD",{});var uf=o(ns);Ui=i(uf,"7.8it/s"),uf.forEach(a),zt.forEach(a),Ci=f(E),te=n(E,"TR",{});var Ht=o(te);os=n(Ht,"TD",{});var df=o(os);Fi=i(df,"NVIDIA A10G"),df.forEach(a),Ri=f(Ht),rs=n(Ht,"TD",{});var mf=o(rs);Mi=i(mf,"8.88it/s"),mf.forEach(a),Vi=f(Ht),is=n(Ht,"TD",{});var _f=o(is);zi=i(_f,"15.6it/s"),_f.forEach(a),Ht.forEach(a),Hi=f(E),ae=n(E,"TR",{});var Gt=o(ae);ls=n(Gt,"TD",{});var vf=o(ls);Gi=i(vf,"NVIDIA RTX A6000"),vf.forEach(a),Oi=f(Gt),ps=n(Gt,"TD",{});var yf=o(ps);Bi=i(yf,"11.7it/s"),yf.forEach(a),Li=f(Gt),fs=n(Gt,"TD",{});var wf=o(fs);Xi=i(wf,"21.09it/s"),wf.forEach(a),Gt.forEach(a),Yi=f(E),se=n(E,"TR",{});var Ot=o(se);cs=n(Ot,"TD",{});var bf=o(cs);Wi=i(bf,"NVIDIA TITAN RTX"),bf.forEach(a),Ki=f(Ot),hs=n(Ot,"TD",{});var gf=o(hs);Qi=i(gf,"12.51it/s"),gf.forEach(a),Ji=f(Ot),us=n(Ot,"TD",{});var $f=o(us);Zi=i($f,"18.22it/s"),$f.forEach(a),Ot.forEach(a),el=f(E),ne=n(E,"TR",{});var Bt=o(ne);ds=n(Bt,"TD",{});var Ef=o(ds);tl=i(Ef,"A100-SXM4-40GB"),Ef.forEach(a),al=f(Bt),ms=n(Bt,"TD",{});var jf=o(ms);sl=i(jf,"18.6it/s"),jf.forEach(a),nl=f(Bt),_s=n(Bt,"TD",{});var kf=o(_s);ol=i(kf,"29.it/s"),kf.forEach(a),Bt.forEach(a),rl=f(E),oe=n(E,"TR",{});var Lt=o(oe);vs=n(Lt,"TD",{});var Tf=o(vs);il=i(Tf,"A100-SXM-80GB"),Tf.forEach(a),ll=f(Lt),ys=n(Lt,"TD",{});var Df=o(ys);pl=i(Df,"18.7it/s"),Df.forEach(a),fl=f(Lt),ws=n(Lt,"TD",{});var Af=o(ws);cl=i(Af,"29.5it/s"),Af.forEach(a),Lt.forEach(a),E.forEach(a),Bn.forEach(a),$n=f(e),jt=n(e,"P",{});var Pf=o(jt);hl=i(Pf,"To leverage it just make sure you have:"),Pf.forEach(a),En=f(e),N=n(e,"UL",{});var Xt=o(N);bs=n(Xt,"LI",{});var xf=o(bs);ul=i(xf,"PyTorch > 1.12"),xf.forEach(a),dl=f(Xt),gs=n(Xt,"LI",{});var Sf=o(gs);ml=i(Sf,"Cuda available"),Sf.forEach(a),_l=f(Xt),kt=n(Xt,"LI",{});var bl=o(kt);Tt=n(bl,"A",{href:!0});var qf=o(Tt);vl=i(qf,"Installed the xformers library"),qf.forEach(a),yl=i(bl,"."),bl.forEach(a),Xt.forEach(a),jn=f(e),d(st.$$.fragment,e),this.h()},h(){h(g,"name","hf:doc:metadata"),h(g,"content",JSON.stringify(zf)),h(re,"id","memory-and-speed"),h(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(re,"href","#memory-and-speed"),h(T,"class","relative group"),h(xe,"href","https://github.com/facebookresearch/xformers"),h(xe,"rel","nofollow"),h(ot,"href","xformers"),h(le,"id","enable-cudnn-autotuner"),h(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(le,"href","#enable-cudnn-autotuner"),h(H,"class","relative group"),h(Ne,"href","https://developer.nvidia.com/cudnn"),h(Ne,"rel","nofollow"),h(fe,"id","use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(fe,"href","#use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(G,"class","relative group"),h(Ce,"href","https://huggingface.co/docs/transformers/v4.18.0/en/performance#tf32"),h(Ce,"rel","nofollow"),h(he,"id","automatic-mixed-precision-amp"),h(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(he,"href","#automatic-mixed-precision-amp"),h(O,"class","relative group"),h(de,"id","half-precision-weights"),h(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(de,"href","#half-precision-weights"),h(B,"class","relative group"),h(me,"id","sliced-attention-for-additional-memory-savings"),h(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(me,"href","#sliced-attention-for-additional-memory-savings"),h(L,"class","relative group"),h(pt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(ye,"id","sliced-vae-decode-for-larger-batches"),h(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ye,"href","#sliced-vae-decode-for-larger-batches"),h(X,"class","relative group"),h(ht,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(ut,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_xformers_memory_efficient_attention"),h(dt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_slicing"),h(be,"id","offloading-to-cpu-with-accelerate-for-memory-savings"),h(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(be,"href","#offloading-to-cpu-with-accelerate-for-memory-savings"),h(Y,"class","relative group"),h(vt,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_sequential_cpu_offload"),h($e,"id","using-channels-last-memory-format"),h($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h($e,"href","#using-channels-last-memory-format"),h(W,"class","relative group"),h(Ee,"id","tracing"),h(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ee,"href","#tracing"),h(K,"class","relative group"),h(Te,"id","memory-efficient-attention"),h(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Te,"href","#memory-efficient-attention"),h(Q,"class","relative group"),h(tt,"href","https://github.com/HazyResearch/flash-attention"),h(tt,"rel","nofollow"),h(at,"href","https://arxiv.org/pdf/2205.14135.pdf"),h(at,"rel","nofollow"),h(Tt,"href","xformers")},m(e,l){t(document.head,g),c(e,A,l),c(e,T,l),t(T,re),t(re,Yt),m(Pe,Yt,null),t(T,Ln),t(T,Wt),t(Wt,Xn),c(e,Es,l),c(e,j,l),t(j,Yn),t(j,Kt),t(Kt,Wn),t(j,Kn),t(j,xe),t(xe,Qn),t(j,Jn),t(j,ot),t(ot,Zn),t(j,eo),c(e,js,l),c(e,rt,l),t(rt,to),c(e,ks,l),c(e,ie,l),t(ie,Qt),t(Qt,I),t(I,Ts),t(I,ao),t(I,Jt),t(Jt,so),t(I,no),t(I,Zt),t(Zt,oo),t(ie,ro),t(ie,w),t(w,U),t(U,ea),t(ea,io),t(U,lo),t(U,ta),t(ta,po),t(U,fo),t(U,aa),t(aa,co),t(w,ho),t(w,C),t(C,sa),t(sa,uo),t(C,mo),t(C,na),t(na,_o),t(C,vo),t(C,oa),t(oa,yo),t(w,wo),t(w,F),t(F,ra),t(ra,bo),t(F,go),t(F,ia),t(ia,$o),t(F,Eo),t(F,la),t(la,jo),t(w,ko),t(w,R),t(R,pa),t(pa,To),t(R,Do),t(R,fa),t(fa,Ao),t(R,Po),t(R,ca),t(ca,xo),t(w,So),t(w,M),t(M,ha),t(ha,qo),t(M,No),t(M,ua),t(ua,Io),t(M,Uo),t(M,da),t(da,Co),t(w,Fo),t(w,V),t(V,ma),t(ma,Ro),t(V,Mo),t(V,_a),t(_a,Vo),t(V,zo),t(V,va),t(va,Ho),t(w,Go),t(w,z),t(z,ya),t(ya,Oo),t(z,Bo),t(z,wa),t(wa,Lo),t(z,Xo),t(z,ba),t(ba,Yo),c(e,Ds,l),c(e,it,l),t(it,Wo),c(e,As,l),c(e,H,l),t(H,le),t(le,ga),m(Se,ga,null),t(H,Ko),t(H,$a),t($a,Qo),c(e,Ps,l),c(e,qe,l),t(qe,Ne),t(Ne,Jo),t(qe,Zo),c(e,xs,l),c(e,pe,l),t(pe,er),t(pe,Ea),t(Ea,tr),t(pe,ar),c(e,Ss,l),m(Ie,e,l),c(e,qs,l),c(e,G,l),t(G,fe),t(fe,ja),m(Ue,ja,null),t(G,sr),t(G,ka),t(ka,nr),c(e,Ns,l),c(e,ce,l),t(ce,or),t(ce,Ce),t(Ce,rr),t(ce,ir),c(e,Is,l),m(Fe,e,l),c(e,Us,l),c(e,O,l),t(O,he),t(he,Ta),m(Re,Ta,null),t(O,lr),t(O,Da),t(Da,pr),c(e,Cs,l),c(e,P,l),t(P,fr),t(P,Aa),t(Aa,cr),t(P,hr),t(P,Pa),t(Pa,ur),t(P,dr),c(e,Fs,l),m(Me,e,l),c(e,Rs,l),c(e,ue,l),t(ue,mr),t(ue,xa),t(xa,_r),t(ue,vr),c(e,Ms,l),c(e,B,l),t(B,de),t(de,Sa),m(Ve,Sa,null),t(B,yr),t(B,qa),t(qa,wr),c(e,Vs,l),c(e,x,l),t(x,br),t(x,Na),t(Na,gr),t(x,$r),t(x,Ia),t(Ia,Er),t(x,jr),c(e,zs,l),m(ze,e,l),c(e,Hs,l),c(e,L,l),t(L,me),t(me,Ua),m(He,Ua,null),t(L,kr),t(L,Ca),t(Ca,Tr),c(e,Gs,l),c(e,lt,l),t(lt,Dr),c(e,Os,l),m(_e,e,l),c(e,Bs,l),c(e,ve,l),t(ve,Ar),t(ve,pt),t(pt,Pr),t(ve,xr),c(e,Ls,l),m(Ge,e,l),c(e,Xs,l),c(e,ft,l),t(ft,Sr),c(e,Ys,l),c(e,X,l),t(X,ye),t(ye,Fa),m(Oe,Fa,null),t(X,qr),t(X,Ra),t(Ra,Nr),c(e,Ws,l),c(e,ct,l),t(ct,Ir),c(e,Ks,l),c(e,S,l),t(S,Ur),t(S,ht),t(ht,Cr),t(S,Fr),t(S,ut),t(ut,Rr),t(S,Mr),c(e,Qs,l),c(e,we,l),t(we,Vr),t(we,dt),t(dt,zr),t(we,Hr),c(e,Js,l),m(Be,e,l),c(e,Zs,l),c(e,mt,l),t(mt,Gr),c(e,en,l),c(e,Y,l),t(Y,be),t(be,Ma),m(Le,Ma,null),t(Y,Or),t(Y,Va),t(Va,Br),c(e,tn,l),c(e,_t,l),t(_t,Lr),c(e,an,l),c(e,ge,l),t(ge,Xr),t(ge,vt),t(vt,Yr),t(ge,Wr),c(e,sn,l),m(Xe,e,l),c(e,nn,l),c(e,yt,l),t(yt,Kr),c(e,on,l),c(e,wt,l),t(wt,Qr),c(e,rn,l),m(Ye,e,l),c(e,ln,l),c(e,W,l),t(W,$e),t($e,za),m(We,za,null),t(W,Jr),t(W,Ha),t(Ha,Zr),c(e,pn,l),c(e,bt,l),t(bt,ei),c(e,fn,l),c(e,gt,l),t(gt,ti),c(e,cn,l),m(Ke,e,l),c(e,hn,l),c(e,K,l),t(K,Ee),t(Ee,Ga),m(Qe,Ga,null),t(K,ai),t(K,Oa),t(Oa,si),c(e,un,l),c(e,je,l),t(je,ni),t(je,Ba),t(Ba,oi),t(je,ri),c(e,dn,l),c(e,$t,l),t($t,ii),c(e,mn,l),m(Je,e,l),c(e,_n,l),c(e,ke,l),t(ke,li),t(ke,La),t(La,pi),t(ke,fi),c(e,vn,l),m(Ze,e,l),c(e,yn,l),c(e,Q,l),t(Q,Te),t(Te,Xa),m(et,Xa,null),t(Q,ci),t(Q,Ya),t(Ya,hi),c(e,wn,l),c(e,q,l),t(q,ui),t(q,tt),t(tt,di),t(q,mi),t(q,at),t(at,_i),t(q,vi),c(e,bn,l),c(e,Et,l),t(Et,yi),c(e,gn,l),c(e,De,l),t(De,Wa),t(Wa,J),t(J,Ka),t(Ka,wi),t(J,bi),t(J,Qa),t(Qa,gi),t(J,$i),t(J,Ja),t(Ja,Ei),t(De,ji),t(De,b),t(b,Z),t(Z,Za),t(Za,ki),t(Z,Ti),t(Z,es),t(es,Di),t(Z,Ai),t(Z,ts),t(ts,Pi),t(b,xi),t(b,ee),t(ee,as),t(as,Si),t(ee,qi),t(ee,ss),t(ss,Ni),t(ee,Ii),t(ee,ns),t(ns,Ui),t(b,Ci),t(b,te),t(te,os),t(os,Fi),t(te,Ri),t(te,rs),t(rs,Mi),t(te,Vi),t(te,is),t(is,zi),t(b,Hi),t(b,ae),t(ae,ls),t(ls,Gi),t(ae,Oi),t(ae,ps),t(ps,Bi),t(ae,Li),t(ae,fs),t(fs,Xi),t(b,Yi),t(b,se),t(se,cs),t(cs,Wi),t(se,Ki),t(se,hs),t(hs,Qi),t(se,Ji),t(se,us),t(us,Zi),t(b,el),t(b,ne),t(ne,ds),t(ds,tl),t(ne,al),t(ne,ms),t(ms,sl),t(ne,nl),t(ne,_s),t(_s,ol),t(b,rl),t(b,oe),t(oe,vs),t(vs,il),t(oe,ll),t(oe,ys),t(ys,pl),t(oe,fl),t(oe,ws),t(ws,cl),c(e,$n,l),c(e,jt,l),t(jt,hl),c(e,En,l),c(e,N,l),t(N,bs),t(bs,ul),t(N,dl),t(N,gs),t(gs,ml),t(N,_l),t(N,kt),t(kt,Tt),t(Tt,vl),t(kt,yl),c(e,jn,l),m(st,e,l),kn=!0},p(e,[l]){const nt={};l&2&&(nt.$$scope={dirty:l,ctx:e}),_e.$set(nt)},i(e){kn||(_(Pe.$$.fragment,e),_(Se.$$.fragment,e),_(Ie.$$.fragment,e),_(Ue.$$.fragment,e),_(Fe.$$.fragment,e),_(Re.$$.fragment,e),_(Me.$$.fragment,e),_(Ve.$$.fragment,e),_(ze.$$.fragment,e),_(He.$$.fragment,e),_(_e.$$.fragment,e),_(Ge.$$.fragment,e),_(Oe.$$.fragment,e),_(Be.$$.fragment,e),_(Le.$$.fragment,e),_(Xe.$$.fragment,e),_(Ye.$$.fragment,e),_(We.$$.fragment,e),_(Ke.$$.fragment,e),_(Qe.$$.fragment,e),_(Je.$$.fragment,e),_(Ze.$$.fragment,e),_(et.$$.fragment,e),_(st.$$.fragment,e),kn=!0)},o(e){v(Pe.$$.fragment,e),v(Se.$$.fragment,e),v(Ie.$$.fragment,e),v(Ue.$$.fragment,e),v(Fe.$$.fragment,e),v(Re.$$.fragment,e),v(Me.$$.fragment,e),v(Ve.$$.fragment,e),v(ze.$$.fragment,e),v(He.$$.fragment,e),v(_e.$$.fragment,e),v(Ge.$$.fragment,e),v(Oe.$$.fragment,e),v(Be.$$.fragment,e),v(Le.$$.fragment,e),v(Xe.$$.fragment,e),v(Ye.$$.fragment,e),v(We.$$.fragment,e),v(Ke.$$.fragment,e),v(Qe.$$.fragment,e),v(Je.$$.fragment,e),v(Ze.$$.fragment,e),v(et.$$.fragment,e),v(st.$$.fragment,e),kn=!1},d(e){a(g),e&&a(A),e&&a(T),y(Pe),e&&a(Es),e&&a(j),e&&a(js),e&&a(rt),e&&a(ks),e&&a(ie),e&&a(Ds),e&&a(it),e&&a(As),e&&a(H),y(Se),e&&a(Ps),e&&a(qe),e&&a(xs),e&&a(pe),e&&a(Ss),y(Ie,e),e&&a(qs),e&&a(G),y(Ue),e&&a(Ns),e&&a(ce),e&&a(Is),y(Fe,e),e&&a(Us),e&&a(O),y(Re),e&&a(Cs),e&&a(P),e&&a(Fs),y(Me,e),e&&a(Rs),e&&a(ue),e&&a(Ms),e&&a(B),y(Ve),e&&a(Vs),e&&a(x),e&&a(zs),y(ze,e),e&&a(Hs),e&&a(L),y(He),e&&a(Gs),e&&a(lt),e&&a(Os),y(_e,e),e&&a(Bs),e&&a(ve),e&&a(Ls),y(Ge,e),e&&a(Xs),e&&a(ft),e&&a(Ys),e&&a(X),y(Oe),e&&a(Ws),e&&a(ct),e&&a(Ks),e&&a(S),e&&a(Qs),e&&a(we),e&&a(Js),y(Be,e),e&&a(Zs),e&&a(mt),e&&a(en),e&&a(Y),y(Le),e&&a(tn),e&&a(_t),e&&a(an),e&&a(ge),e&&a(sn),y(Xe,e),e&&a(nn),e&&a(yt),e&&a(on),e&&a(wt),e&&a(rn),y(Ye,e),e&&a(ln),e&&a(W),y(We),e&&a(pn),e&&a(bt),e&&a(fn),e&&a(gt),e&&a(cn),y(Ke,e),e&&a(hn),e&&a(K),y(Qe),e&&a(un),e&&a(je),e&&a(dn),e&&a($t),e&&a(mn),y(Je,e),e&&a(_n),e&&a(ke),e&&a(vn),y(Ze,e),e&&a(yn),e&&a(Q),y(et),e&&a(wn),e&&a(q),e&&a(bn),e&&a(Et),e&&a(gn),e&&a(De),e&&a($n),e&&a(jt),e&&a(En),e&&a(N),e&&a(jn),y(st,e)}}}const zf={local:"memory-and-speed",sections:[{local:"enable-cudnn-autotuner",sections:[{local:"use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices",title:"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"}],title:"Enable cuDNN auto-tuner"},{local:"automatic-mixed-precision-amp",title:"Automatic mixed precision (AMP)"},{local:"half-precision-weights",title:"Half precision weights"},{local:"sliced-attention-for-additional-memory-savings",title:"Sliced attention for additional memory savings"},{local:"sliced-vae-decode-for-larger-batches",title:"Sliced VAE decode for larger batches"},{local:"offloading-to-cpu-with-accelerate-for-memory-savings",title:"Offloading to CPU with accelerate for memory savings"},{local:"using-channels-last-memory-format",title:"Using Channels Last memory format"},{local:"tracing",title:"Tracing"},{local:"memory-efficient-attention",title:"Memory Efficient Attention"}],title:"Memory and speed"};function Hf($s){return Ff(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xf extends Nf{constructor(g){super();If(this,g,Hf,Vf,Uf,{})}}export{Xf as default,zf as metadata};
