import{S as un,i as gn,s as hn,e as i,k as c,w,t as o,M as _n,c as s,d as n,m as d,a,x as D,h as r,b as l,G as e,g as v,y as P,q as S,o as $,B as x,v as bn,L as vn}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as ae}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as In}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as mn}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as yn}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function wn(Se){let g,j,b,h,k;return h=new In({props:{code:`import requests
import torch
from PIL import Image
from io import BytesIO

from diffusers import StableDiffusionImg2ImgPipeline

device = "cuda"
model_id_or_path = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
pipe = pipe.to(device)

url = "https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg"

response = requests.get(url)
init_image = Image.open(BytesIO(response.content)).convert("RGB")
init_image = init_image.resize((768, 512))

prompt = "A fantasy landscape, trending on artstation"

images = pipe(prompt=prompt, image=init_image, strength=0.75, guidance_scale=7.5).images
images[0].save("fantasy_landscape.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> io <span class="hljs-keyword">import</span> BytesIO

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionImg2ImgPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model_id_or_path = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionImg2ImgPipeline.from_pretrained(model_id_or_path, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(device)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://raw.githubusercontent.com/CompVis/stable-diffusion/main/assets/stable-samples/img2img/sketch-mountains-input.jpg&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>response = requests.get(url)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = Image.<span class="hljs-built_in">open</span>(BytesIO(response.content)).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = init_image.resize((<span class="hljs-number">768</span>, <span class="hljs-number">512</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;A fantasy landscape, trending on artstation&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipe(prompt=prompt, image=init_image, strength=<span class="hljs-number">0.75</span>, guidance_scale=<span class="hljs-number">7.5</span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;fantasy_landscape.png&quot;</span>)`}}),{c(){g=i("p"),j=o("Examples:"),b=c(),w(h.$$.fragment)},l(f){g=s(f,"P",{});var E=a(g);j=r(E,"Examples:"),E.forEach(n),b=d(f),D(h.$$.fragment,f)},m(f,E){v(f,g,E),e(g,j),v(f,b,E),P(h,f,E),k=!0},p:vn,i(f){k||(S(h.$$.fragment,f),k=!0)},o(f){$(h.$$.fragment,f),k=!1},d(f){f&&n(g),f&&n(b),x(h,f)}}}function Dn(Se){let g,j,b,h,k,f,E,pe,ze,$e,L,A,me,G,Ge,ue,Ve,xe,_,We,V,Be,Fe,W,He,Ke,B,Re,Je,F,Qe,Xe,oe,Ye,Ze,ke,H,et,K,tt,Ee,q,re,nt,it,le,st,Ce,p,R,at,ge,ot,rt,J,lt,ce,ct,dt,ft,C,Q,pt,he,mt,ut,M,gt,T,X,ht,_e,_t,bt,be,vt,It,O,Y,yt,Z,wt,ve,Dt,Pt,St,I,ee,$t,Ie,xt,kt,ye,Et,Ct,we,Tt,Lt,N,te,jt,De,At,qt,U,ne,Mt,ie,Ot,Pe,Nt,Ut,Te;return f=new mn({}),G=new mn({}),R=new ae({props:{name:"class diffusers.StableDiffusionImg2ImgPipeline",anchor:"diffusers.StableDiffusionImg2ImgPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_pndm.PNDMScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler, diffusers.schedulers.scheduling_euler_discrete.EulerDiscreteScheduler, diffusers.schedulers.scheduling_euler_ancestral_discrete.EulerAncestralDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep.DPMSolverMultistepScheduler]"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L100"}}),Q=new ae({props:{name:"__call__",anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]]"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"strength",val:": float = 0.8"},{name:"num_inference_steps",val:": typing.Optional[int] = 50"},{name:"guidance_scale",val:": typing.Optional[float] = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": typing.Optional[float] = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference. This parameter will be modulated by <code>strength</code>.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. Ignored when not using guidance (i.e., ignored
if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L488",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),M=new yn({props:{anchor:"diffusers.StableDiffusionImg2ImgPipeline.__call__.example",$$slots:{default:[wn]},$$scope:{ctx:Se}}}),X=new ae({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maxium amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L852"}}),Y=new ae({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L868"}}),ee=new ae({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L817"}}),te=new ae({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionImg2ImgPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L829"}}),ne=new ae({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionImg2ImgPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_img2img.py#L227"}}),{c(){g=i("meta"),j=c(),b=i("h1"),h=i("a"),k=i("span"),w(f.$$.fragment),E=c(),pe=i("span"),ze=o("Image-to-Image Generation"),$e=c(),L=i("h2"),A=i("a"),me=i("span"),w(G.$$.fragment),Ge=c(),ue=i("span"),Ve=o("StableDiffusionImg2ImgPipeline"),xe=c(),_=i("p"),We=o("The Stable Diffusion model was created by the researchers and engineers from "),V=i("a"),Be=o("CompVis"),Fe=o(", "),W=i("a"),He=o("Stability AI"),Ke=o(", "),B=i("a"),Re=o("runway"),Je=o(", and "),F=i("a"),Qe=o("LAION"),Xe=o(". The "),oe=i("a"),Ye=o("StableDiffusionImg2ImgPipeline"),Ze=o(" lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),ke=c(),H=i("p"),et=o("The original codebase can be found here: "),K=i("a"),tt=o("CampVis/stable-diffusion"),Ee=c(),q=i("p"),re=i("a"),nt=o("StableDiffusionImg2ImgPipeline"),it=o(" is compatible with all Stable Diffusion checkpoints for "),le=i("a"),st=o("Text-to-Image"),Ce=c(),p=i("div"),w(R.$$.fragment),at=c(),ge=i("p"),ot=o("Pipeline for text-guided image to image generation using Stable Diffusion."),rt=c(),J=i("p"),lt=o("This model inherits from "),ce=i("a"),ct=o("DiffusionPipeline"),dt=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),ft=c(),C=i("div"),w(Q.$$.fragment),pt=c(),he=i("p"),mt=o("Function invoked when calling the pipeline for generation."),ut=c(),w(M.$$.fragment),gt=c(),T=i("div"),w(X.$$.fragment),ht=c(),_e=i("p"),_t=o("Enable sliced attention computation."),bt=c(),be=i("p"),vt=o(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),It=c(),O=i("div"),w(Y.$$.fragment),yt=c(),Z=i("p"),wt=o("Disable sliced attention computation. If "),ve=i("code"),Dt=o("enable_attention_slicing"),Pt=o(` was previously invoked, this method will go
back to computing attention in one step.`),St=c(),I=i("div"),w(ee.$$.fragment),$t=c(),Ie=i("p"),xt=o("Enable memory efficient attention as implemented in xformers."),kt=c(),ye=i("p"),Et=o(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Ct=c(),we=i("p"),Tt=o(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Lt=c(),N=i("div"),w(te.$$.fragment),jt=c(),De=i("p"),At=o("Disable memory efficient attention as implemented in xformers."),qt=c(),U=i("div"),w(ne.$$.fragment),Mt=c(),ie=i("p"),Ot=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Pe=i("code"),Nt=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Ut=o("forward` method called."),this.h()},l(t){const m=_n('[data-svelte="svelte-1phssyn"]',document.head);g=s(m,"META",{name:!0,content:!0}),m.forEach(n),j=d(t),b=s(t,"H1",{class:!0});var se=a(b);h=s(se,"A",{id:!0,class:!0,href:!0});var Gt=a(h);k=s(Gt,"SPAN",{});var Vt=a(k);D(f.$$.fragment,Vt),Vt.forEach(n),Gt.forEach(n),E=d(se),pe=s(se,"SPAN",{});var Wt=a(pe);ze=r(Wt,"Image-to-Image Generation"),Wt.forEach(n),se.forEach(n),$e=d(t),L=s(t,"H2",{class:!0});var Le=a(L);A=s(Le,"A",{id:!0,class:!0,href:!0});var Bt=a(A);me=s(Bt,"SPAN",{});var Ft=a(me);D(G.$$.fragment,Ft),Ft.forEach(n),Bt.forEach(n),Ge=d(Le),ue=s(Le,"SPAN",{});var Ht=a(ue);Ve=r(Ht,"StableDiffusionImg2ImgPipeline"),Ht.forEach(n),Le.forEach(n),xe=d(t),_=s(t,"P",{});var y=a(_);We=r(y,"The Stable Diffusion model was created by the researchers and engineers from "),V=s(y,"A",{href:!0,rel:!0});var Kt=a(V);Be=r(Kt,"CompVis"),Kt.forEach(n),Fe=r(y,", "),W=s(y,"A",{href:!0,rel:!0});var Rt=a(W);He=r(Rt,"Stability AI"),Rt.forEach(n),Ke=r(y,", "),B=s(y,"A",{href:!0,rel:!0});var Jt=a(B);Re=r(Jt,"runway"),Jt.forEach(n),Je=r(y,", and "),F=s(y,"A",{href:!0,rel:!0});var Qt=a(F);Qe=r(Qt,"LAION"),Qt.forEach(n),Xe=r(y,". The "),oe=s(y,"A",{href:!0});var Xt=a(oe);Ye=r(Xt,"StableDiffusionImg2ImgPipeline"),Xt.forEach(n),Ze=r(y," lets you pass a text prompt and an initial image to condition the generation of new images using Stable Diffusion."),y.forEach(n),ke=d(t),H=s(t,"P",{});var zt=a(H);et=r(zt,"The original codebase can be found here: "),K=s(zt,"A",{href:!0,rel:!0});var Yt=a(K);tt=r(Yt,"CampVis/stable-diffusion"),Yt.forEach(n),zt.forEach(n),Ee=d(t),q=s(t,"P",{});var je=a(q);re=s(je,"A",{href:!0});var Zt=a(re);nt=r(Zt,"StableDiffusionImg2ImgPipeline"),Zt.forEach(n),it=r(je," is compatible with all Stable Diffusion checkpoints for "),le=s(je,"A",{href:!0});var en=a(le);st=r(en,"Text-to-Image"),en.forEach(n),je.forEach(n),Ce=d(t),p=s(t,"DIV",{class:!0});var u=a(p);D(R.$$.fragment,u),at=d(u),ge=s(u,"P",{});var tn=a(ge);ot=r(tn,"Pipeline for text-guided image to image generation using Stable Diffusion."),tn.forEach(n),rt=d(u),J=s(u,"P",{});var Ae=a(J);lt=r(Ae,"This model inherits from "),ce=s(Ae,"A",{href:!0});var nn=a(ce);ct=r(nn,"DiffusionPipeline"),nn.forEach(n),dt=r(Ae,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Ae.forEach(n),ft=d(u),C=s(u,"DIV",{class:!0});var de=a(C);D(Q.$$.fragment,de),pt=d(de),he=s(de,"P",{});var sn=a(he);mt=r(sn,"Function invoked when calling the pipeline for generation."),sn.forEach(n),ut=d(de),D(M.$$.fragment,de),de.forEach(n),gt=d(u),T=s(u,"DIV",{class:!0});var fe=a(T);D(X.$$.fragment,fe),ht=d(fe),_e=s(fe,"P",{});var an=a(_e);_t=r(an,"Enable sliced attention computation."),an.forEach(n),bt=d(fe),be=s(fe,"P",{});var on=a(be);vt=r(on,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),on.forEach(n),fe.forEach(n),It=d(u),O=s(u,"DIV",{class:!0});var qe=a(O);D(Y.$$.fragment,qe),yt=d(qe),Z=s(qe,"P",{});var Me=a(Z);wt=r(Me,"Disable sliced attention computation. If "),ve=s(Me,"CODE",{});var rn=a(ve);Dt=r(rn,"enable_attention_slicing"),rn.forEach(n),Pt=r(Me,` was previously invoked, this method will go
back to computing attention in one step.`),Me.forEach(n),qe.forEach(n),St=d(u),I=s(u,"DIV",{class:!0});var z=a(I);D(ee.$$.fragment,z),$t=d(z),Ie=s(z,"P",{});var ln=a(Ie);xt=r(ln,"Enable memory efficient attention as implemented in xformers."),ln.forEach(n),kt=d(z),ye=s(z,"P",{});var cn=a(ye);Et=r(cn,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),cn.forEach(n),Ct=d(z),we=s(z,"P",{});var dn=a(we);Tt=r(dn,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),dn.forEach(n),z.forEach(n),Lt=d(u),N=s(u,"DIV",{class:!0});var Oe=a(N);D(te.$$.fragment,Oe),jt=d(Oe),De=s(Oe,"P",{});var fn=a(De);At=r(fn,"Disable memory efficient attention as implemented in xformers."),fn.forEach(n),Oe.forEach(n),qt=d(u),U=s(u,"DIV",{class:!0});var Ne=a(U);D(ne.$$.fragment,Ne),Mt=d(Ne),ie=s(Ne,"P",{});var Ue=a(ie);Ot=r(Ue,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Pe=s(Ue,"CODE",{});var pn=a(Pe);Nt=r(pn,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),pn.forEach(n),Ut=r(Ue,"forward` method called."),Ue.forEach(n),Ne.forEach(n),u.forEach(n),this.h()},h(){l(g,"name","hf:doc:metadata"),l(g,"content",JSON.stringify(Pn)),l(h,"id","imagetoimage-generation"),l(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(h,"href","#imagetoimage-generation"),l(b,"class","relative group"),l(A,"id","diffusers.StableDiffusionImg2ImgPipeline"),l(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(A,"href","#diffusers.StableDiffusionImg2ImgPipeline"),l(L,"class","relative group"),l(V,"href","https://github.com/CompVis"),l(V,"rel","nofollow"),l(W,"href","https://stability.ai/"),l(W,"rel","nofollow"),l(B,"href","https://github.com/runwayml"),l(B,"rel","nofollow"),l(F,"href","https://laion.ai/"),l(F,"rel","nofollow"),l(oe,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),l(K,"href","https://github.com/CompVis/stable-diffusion/blob/main/scripts/img2img.py"),l(K,"rel","nofollow"),l(re,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/img2img#diffusers.StableDiffusionImg2ImgPipeline"),l(le,"href","./text2img"),l(ce,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),l(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,m){e(document.head,g),v(t,j,m),v(t,b,m),e(b,h),e(h,k),P(f,k,null),e(b,E),e(b,pe),e(pe,ze),v(t,$e,m),v(t,L,m),e(L,A),e(A,me),P(G,me,null),e(L,Ge),e(L,ue),e(ue,Ve),v(t,xe,m),v(t,_,m),e(_,We),e(_,V),e(V,Be),e(_,Fe),e(_,W),e(W,He),e(_,Ke),e(_,B),e(B,Re),e(_,Je),e(_,F),e(F,Qe),e(_,Xe),e(_,oe),e(oe,Ye),e(_,Ze),v(t,ke,m),v(t,H,m),e(H,et),e(H,K),e(K,tt),v(t,Ee,m),v(t,q,m),e(q,re),e(re,nt),e(q,it),e(q,le),e(le,st),v(t,Ce,m),v(t,p,m),P(R,p,null),e(p,at),e(p,ge),e(ge,ot),e(p,rt),e(p,J),e(J,lt),e(J,ce),e(ce,ct),e(J,dt),e(p,ft),e(p,C),P(Q,C,null),e(C,pt),e(C,he),e(he,mt),e(C,ut),P(M,C,null),e(p,gt),e(p,T),P(X,T,null),e(T,ht),e(T,_e),e(_e,_t),e(T,bt),e(T,be),e(be,vt),e(p,It),e(p,O),P(Y,O,null),e(O,yt),e(O,Z),e(Z,wt),e(Z,ve),e(ve,Dt),e(Z,Pt),e(p,St),e(p,I),P(ee,I,null),e(I,$t),e(I,Ie),e(Ie,xt),e(I,kt),e(I,ye),e(ye,Et),e(I,Ct),e(I,we),e(we,Tt),e(p,Lt),e(p,N),P(te,N,null),e(N,jt),e(N,De),e(De,At),e(p,qt),e(p,U),P(ne,U,null),e(U,Mt),e(U,ie),e(ie,Ot),e(ie,Pe),e(Pe,Nt),e(ie,Ut),Te=!0},p(t,[m]){const se={};m&2&&(se.$$scope={dirty:m,ctx:t}),M.$set(se)},i(t){Te||(S(f.$$.fragment,t),S(G.$$.fragment,t),S(R.$$.fragment,t),S(Q.$$.fragment,t),S(M.$$.fragment,t),S(X.$$.fragment,t),S(Y.$$.fragment,t),S(ee.$$.fragment,t),S(te.$$.fragment,t),S(ne.$$.fragment,t),Te=!0)},o(t){$(f.$$.fragment,t),$(G.$$.fragment,t),$(R.$$.fragment,t),$(Q.$$.fragment,t),$(M.$$.fragment,t),$(X.$$.fragment,t),$(Y.$$.fragment,t),$(ee.$$.fragment,t),$(te.$$.fragment,t),$(ne.$$.fragment,t),Te=!1},d(t){n(g),t&&n(j),t&&n(b),x(f),t&&n($e),t&&n(L),x(G),t&&n(xe),t&&n(_),t&&n(ke),t&&n(H),t&&n(Ee),t&&n(q),t&&n(Ce),t&&n(p),x(R),x(Q),x(M),x(X),x(Y),x(ee),x(te),x(ne)}}}const Pn={local:"imagetoimage-generation",sections:[{local:"diffusers.StableDiffusionImg2ImgPipeline",title:"StableDiffusionImg2ImgPipeline"}],title:"Image-to-Image Generation"};function Sn(Se){return bn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Tn extends un{constructor(g){super();gn(this,g,Sn,Dn,hn,{})}}export{Tn as default,Pn as metadata};
